<template>
  <b-card>
    <FormGenerator
      :key="labelFor"
      :selected-shape="nodeImport"
      :shapes="wrapperDataset"
      :defined-subject="definedSubject"
      :directly-create-rdf-type="false"
      :locale="languageCode"
      :form-data="objectAttachedMetadata"
      :disabled-mode="disabledMode || locked"
      :fixed-values="providedFixedValues"
      :fixed-value-mode="fixedValueMode"
      :class-receiver="classReceiver"
      :user-receiver="userReceiver"
      @update:form-data="updateMetadataValue"
      @update:fixed-values="inputFixedValues"
    />
  </b-card>
</template>

<script lang="ts">
import type { Dataset, Quad_Object, Quad_Subject } from '@rdfjs/types';
import factory from 'rdf-ext';
import {
  InvisibleFixedValue,
  DefaultFixedValue,
  FixedFixedValue,
  type FixedValues,
} from '@/types/fixedValues';
import { retrieveChildren } from '@/util/linkedData';
import type { User } from '@/types/user';

export default defineComponent({
  name: 'InputShape',
  components: {
    FormGenerator: defineAsyncComponent(() => import('../FormGenerator.vue')),
  },
  props: {
    attachedMetadata: {
      required: true,
      type: Object as PropType<Dataset>,
    },
    wrapperDataset: {
      required: true,
      type: Object as PropType<Dataset>,
    },
    nodeImport: {
      required: true,
      type: String,
    },
    locked: {
      default: false,
      type: Boolean,
    },
    required: {
      default: false,
      type: Boolean,
    },
    entry: {
      required: true,
      type: Object as PropType<Quad_Object>,
    },
    disabledMode: {
      default: false,
      type: Boolean,
    },
    languageCode: {
      default: 'en',
      type: String,
    },
    fixedValues: {
      default: () => ({}),
      type: Object as PropType<FixedValues>,
    },
    fixedValueMode: {
      default: false,
      type: Boolean,
    },
    targetClass: {
      required: true,
      type: Object as PropType<Quad_Object>,
    },
    classReceiver: {
      default: () => retrieveChildren,
      type: Function as PropType<typeof retrieveChildren>,
    },
    userReceiver: {
      default: () => {
        return async () => ({});
      },
      type: Function as PropType<() => Promise<User>>,
    },
  },
  data() {
    return {
      labelFor: 'shape' + (Math.random() + 1).toString(36).substring(7),
      objectAttachedMetadata: factory.dataset() as unknown as Dataset,
    };
  },
  computed: {
    definedSubject(): Quad_Subject {
      // Fallback that should not occur
      if (this.entry.termType === 'Literal') {
        return factory.blankNode();
      }
      return this.entry;
    },
    providedFixedValues(): FixedValues {
      const providedFixedValues: FixedValues = {};
      for (const entries of Object.entries(this.fixedValues)) {
        const defaultFixedValue = entries[1][DefaultFixedValue];
        const fixedFixedValue = entries[1][FixedFixedValue];
        const invisibleFixedValue = entries[1][InvisibleFixedValue];
        providedFixedValues[entries[0]] = {
          [DefaultFixedValue]: defaultFixedValue
            ? defaultFixedValue.filter(
                (entry) =>
                  entry.targetClass &&
                  entry.targetClass !== this.targetClass.value,
              )
            : [],
          [FixedFixedValue]: fixedFixedValue
            ? fixedFixedValue.filter(
                (entry) =>
                  entry.targetClass &&
                  entry.targetClass !== this.targetClass.value,
              )
            : [],
          [InvisibleFixedValue]: invisibleFixedValue
            ? invisibleFixedValue.filter(
                (entry) =>
                  entry.targetClass &&
                  entry.targetClass !== this.targetClass.value,
              )
            : [],
        };
      }
      return providedFixedValues;
    },
  },
  watch: {
    entry() {
      this.loadData();
    },
  },
  mounted() {
    this.loadData();
  },
  methods: {
    updateMetadataValue(attachedMetadata: Dataset) {
      this.objectAttachedMetadata = attachedMetadata;
      this.$emit('update:metadata-value', this.entry);
      this.$emit(
        'triggerUpdateDataset',
        this.entry,
        this.objectAttachedMetadata,
      );
    },
    inputFixedValues(fixedValues: FixedValues, targetClass: Quad_Object) {
      this.$emit('update:fixed-values', fixedValues, targetClass);
    },
    loadData() {
      this.objectAttachedMetadata = this.attachedMetadata;
    },
  },
});
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped></style>
